/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { ButtonProps } from '../../';
import { DefaultProps } from '../../common-types';
import { DropDownButtonProps } from '../DropDownButton';
declare const Filters: ({ filters, views, schema, disabled, viewScopes, onFiltersUpdate, onViewsUpdate, addFilterButtonProps, viewsMenuButtonProps, renderMode, dark, compact, }: FiltersProps) => JSX.Element;
export interface EditModel {
    field: string;
    operator: string;
    value: string | number | {
        [k: string]: string;
    };
}
export interface ViewScope {
    slug: string;
    name: string;
    label?: string;
}
export interface FiltersView {
    id: string;
    name: string;
    scope?: string | null;
    filters: JSONSchema6[];
}
export interface FilterSignature {
    field: string;
    operator: string;
    value: string | number | boolean | {
        [k: string]: string;
    };
}
export declare type FilterRenderMode = 'all' | 'add' | 'search' | 'views' | 'summary';
export interface DataTypeModel {
    operators: {
        [key: string]: {
            getLabel: (schema: JSONSchema6) => string;
        };
    };
    decodeFilter(filter: JSONSchema6): null | FilterSignature;
    createFilter(field: string, operator: string, value: any, schema: JSONSchema6): JSONSchema6;
    Edit(props: DataTypeEditProps): JSX.Element;
}
export interface DataTypeEditProps {
    schema: JSONSchema6;
    value?: any;
    onUpdate: (value: string | number | boolean) => void;
    operator: string;
    slim?: boolean;
}
export interface FiltersProps extends DefaultProps {
    disabled?: boolean;
    filters?: JSONSchema6[];
    views?: FiltersView[];
    viewScopes?: ViewScope[];
    onFiltersUpdate?: (filters: JSONSchema6[]) => void;
    onViewsUpdate?: (views: FiltersView[]) => void;
    schema: JSONSchema6;
    addFilterButtonProps?: ButtonProps;
    viewsMenuButtonProps?: DropDownButtonProps;
    renderMode?: FilterRenderMode | FilterRenderMode[];
    dark?: boolean;
    compact?: boolean[];
}
export default Filters;
