"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var faFilter_1 = require("@fortawesome/free-solid-svg-icons/faFilter");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var castArray_1 = __importDefault(require("lodash/castArray"));
var includes_1 = __importDefault(require("lodash/includes"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var reject_1 = __importDefault(require("lodash/reject"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var __1 = require("../../");
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Flex_1 = require("../Flex");
var Search_1 = __importDefault(require("../Search"));
var FilterModal_1 = require("./FilterModal");
var SchemaSieve = __importStar(require("./SchemaSieve"));
var Summary_1 = __importDefault(require("./Summary"));
var ViewsMenu_1 = __importDefault(require("./ViewsMenu"));
var SearchWrapper = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tflex-basis: 500px;\n"], ["\n\tflex-basis: 500px;\n"])));
var FilterWrapper = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var flattenViews = function (views) {
    return views.map(function (_a) {
        var filters = _a.filters, view = __rest(_a, ["filters"]);
        return (__assign(__assign({}, view), { filters: filters.map(function (filter) { return SchemaSieve.flattenSchema(filter); }) }));
    });
};
var shouldRenderComponent = function (mode, renderMode) {
    if (!renderMode) {
        return true;
    }
    var allowedModes = castArray_1.default(renderMode);
    if (includes_1.default(allowedModes, 'all')) {
        return true;
    }
    return includes_1.default(allowedModes, mode);
};
var Filters = function (_a) {
    var filters = _a.filters, views = _a.views, schema = _a.schema, disabled = _a.disabled, viewScopes = _a.viewScopes, onFiltersUpdate = _a.onFiltersUpdate, onViewsUpdate = _a.onViewsUpdate, addFilterButtonProps = _a.addFilterButtonProps, viewsMenuButtonProps = _a.viewsMenuButtonProps, renderMode = _a.renderMode, dark = _a.dark, compact = _a.compact;
    var flatSchema = SchemaSieve.flattenSchema(schema);
    var flatViews = flattenViews(views || []);
    var flatFilters = (filters || []).map(function (filter) {
        return SchemaSieve.flattenSchema(filter);
    });
    var shouldHideLabel = useBreakpoint_1.useBreakpoint(compact || [false]);
    var _b = React.useState(false), showModal = _b[0], setshowModal = _b[1];
    var _c = React.useState(''), searchString = _c[0], setSearchString = _c[1];
    var _d = React.useState(), editingFilter = _d[0], setEditingFilter = _d[1];
    var _e = React.useState(flatFilters), filtersState = _e[0], setFiltersState = _e[1];
    var _f = React.useState(flatViews), viewsState = _f[0], setViewsState = _f[1];
    var _g = React.useState(flatSchema), schemaState = _g[0], setschemaState = _g[1];
    var _h = React.useState([
        SchemaSieve.getCleanEditModel(flatSchema),
    ]), edit = _h[0], setEdit = _h[1];
    React.useEffect(function () {
        return onFiltersUpdate &&
            onFiltersUpdate(filtersState.map(function (filter) { return SchemaSieve.unflattenSchema(filter); }));
    }, [filtersState]);
    React.useEffect(function () { return onViewsUpdate && onViewsUpdate(viewsState); }, [
        viewsState,
    ]);
    React.useEffect(function () {
        if (!isEqual_1.default(filtersState, flatFilters)) {
            setFiltersState(flatFilters);
        }
    }, [filters]);
    React.useEffect(function () {
        if (!isEqual_1.default(viewsState, flatViews)) {
            setViewsState(flatViews);
        }
    }, [views]);
    React.useEffect(function () {
        if (!isEqual_1.default(schemaState, flatSchema)) {
            setschemaState(flatSchema);
        }
    }, [schema]);
    var addFilter = function (edit) {
        var newFilter = SchemaSieve.createFilter(schema, edit);
        var currentFilters = !!editingFilter
            ? filtersState.map(function (filter) {
                return filter.$id === editingFilter ? newFilter : filter;
            })
            : __spreadArrays(filtersState, [newFilter]);
        setFiltersState(currentFilters);
        setEdit([SchemaSieve.getCleanEditModel(schemaState)]);
        setshowModal(false);
        setEditingFilter(null);
    };
    var editFilter = function (filter) {
        var signatures = SchemaSieve.decodeFilter(schemaState, filter);
        setEdit(signatures);
        setEditingFilter(filter.$id);
        setshowModal(true);
    };
    var removeFilter = function (_a) {
        var $id = _a.$id, title = _a.title;
        if (title === SchemaSieve.FULL_TEXT_SLUG) {
            setSearchString('');
        }
        setFiltersState(reject_1.default(filtersState, { $id: $id }));
    };
    var clearAllFilters = function () {
        setFiltersState([]);
        setSearchString('');
    };
    var saveView = function (name, scope) {
        var view = {
            id: utils_1.randomString(),
            name: name,
            scope: scope,
            filters: filtersState,
        };
        setViewsState(function (prevViews) { return __spreadArrays(prevViews, [view]); });
    };
    var deleteView = function (_a) {
        var id = _a.id;
        setViewsState(reject_1.default(viewsState, { id: id }));
    };
    var setSimpleSearch = function (term) {
        var newFilters = term
            ? SchemaSieve.upsertFullTextSearch(schemaState, filtersState, term)
            : SchemaSieve.removeFullTextSearch(filtersState);
        setSearchString(term);
        setFiltersState(newFilters);
    };
    return (React.createElement(FilterWrapper, { mb: 3 },
        React.createElement(Flex_1.Flex, { justifyContent: "space-between" },
            shouldRenderComponent('add', renderMode) && (React.createElement(__1.Button, __assign({ mr: 30, disabled: disabled, primary: true, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFilter_1.faFilter }), onClick: function () {
                    setshowModal(true);
                    setEditingFilter(null);
                } }, addFilterButtonProps, { label: shouldHideLabel ? undefined : 'Add filter' }))),
            shouldRenderComponent('search', renderMode) && (React.createElement(SearchWrapper, null,
                React.createElement(Search_1.default, { dark: dark, disabled: disabled, value: searchString, onChange: function (e) {
                        return setSimpleSearch(e.target.value);
                    } }))),
            shouldRenderComponent('views', renderMode) && (React.createElement(ViewsMenu_1.default, { dark: dark, buttonProps: viewsMenuButtonProps, disabled: disabled, views: viewsState || flatViews, schema: schema, hasMultipleScopes: viewScopes && viewScopes.length > 1, setFilters: function (filters) { return setFiltersState(filters); }, deleteView: function (view) { return deleteView(view); }, renderMode: renderMode, shouldHideLabel: shouldHideLabel }))),
        showModal && (React.createElement(FilterModal_1.FilterModal, { addFilter: function (edit) { return addFilter(edit); }, onClose: function () { return setshowModal(false); }, schema: schemaState, edit: edit })),
        shouldRenderComponent('summary', renderMode) &&
            !!filtersState.length &&
            !disabled && (React.createElement(Summary_1.default, { scopes: viewScopes, edit: function (filter) { return editFilter(filter); }, delete: function (filter) { return removeFilter(filter); }, saveView: function (name, scope) { return saveView(name, scope); }, clearAllFilters: clearAllFilters, filters: filtersState, views: viewsState, schema: schemaState }))));
};
exports.default = Filters;
var templateObject_1, templateObject_2;
